//
//  BFRecordExport.swift.swift
//  BFRecordScreenKit
//
//  Created by 胡志强 on 2021/11/25.
//

import Foundation
import AVFoundation
import BFFramework

public class BFRecordExport {
    public var progress : ((Float)->Void)?
    var count = 0
    var timerr : Timer?
    
    var asset:AVAsset?
    var voiceList:[PQVoiceModel]? {
        didSet {
            audioAsset = voiceList?.map({ model in
                AVURLAsset(url: URL(fileURLWithPath: model.wavFilePath))
            })
            
        }
    }
    var audioAsset : [AVURLAsset]?
    
    var exporter : PQCompositionExporter?
    var mStickers = [PQEditVisionTrackMaterialsModel]()
    
    deinit {
        timerr?.invalidate()
        timerr = nil
    }
    public init(){}

    
    //MARK: -
    public func start(){
        guard timerr == nil else {
            return
        }

        timerr = Timer.scheduledTimer(timeInterval: 1, target: self, selector: #selector(updateCounter), userInfo: nil, repeats: true)
        RunLoop.current.add(timerr!, forMode: .common)
        timerr?.fire()
        
        
        // 1,背景视频素材
        let bgMovieInfo: PQEditVisionTrackMaterialsModel = PQEditVisionTrackMaterialsModel()
        bgMovieInfo.type = StickerType.VIDEO.rawValue
        bgMovieInfo.locationPath = (asset as? AVURLAsset)?.url.absoluteString ?? ""
        bgMovieInfo.timelineIn = 0
        bgMovieInfo.timelineOut = CMTimeGetSeconds(asset?.duration ?? CMTime.zero)
        bgMovieInfo.model_in = bgMovieInfo.timelineIn
        bgMovieInfo.out = bgMovieInfo.timelineOut
        bgMovieInfo.canvasFillType = stickerContentMode.aspectFitStr.rawValue
        mStickers.append(bgMovieInfo)
    
        beginExport(videoStickers: mStickers, audioAsset: [(self.asset as! AVURLAsset)])
    }
    
    func beginExport(videoStickers:[PQEditVisionTrackMaterialsModel], audioAsset: [AVURLAsset]) {
 
        
    }
    
    func dealAsset(){
//        asset?.tracks.first(where: { track in
//            if track.mediaType == .audio{
//
//            }
//        })
    }
    
    @objc func updateCounter() {
        if self.count == 100 {
            timerr?.invalidate()
            timerr = nil
            return
        }
        self.count += 1
        self.progress?(Float(self.count)/100.0)
    }
    
    func getVideoSize() -> CGSize{
        var size = CGSize.zero
        self.asset?.tracks.forEach({ track in
            if track.mediaType == .video{
                let realSize = __CGSizeApplyAffineTransform(track.naturalSize, track.preferredTransform)
                size = CGSize(width: abs(realSize.width), height: abs(realSize.height))
            }
        })
        
        return size
    }
}
