//
//  PhotoVideoListController.swift
//  BFRecordScreenKit_Example
//
//  Created by 胡志强 on 2021/11/23.
//  Copyright © 2021 CocoaPods. All rights reserved.
//

import Foundation
import BFUIKit
import BFMaterialKit
import UIKit
import BFRecordScreenKit
import Photos


class PhotoVideoListController: BFBaseViewController {
    
    var chosedAsset:PHAsset?
    
    lazy var photoMaterialVc: BFPhotosMaterialController = {
        let vc = BFPhotosMaterialController()
        vc.view.frame = CGRect(x: 0, y: cDevice_iPhoneNavBarAndStatusBarHei, width: cScreenWidth, height: cScreenHeigth - cDevice_iPhoneNavBarAndStatusBarHei)
        vc.view.backgroundColor = .black
        vc.selectedMaterialHandle = { [weak self] currentMaterialData, selectedPhotoData, _, _ in
            if currentMaterialData?.isSelected ?? false{
                self?.chosedAsset = currentMaterialData
                if selectedPhotoData.count == 2 {
                    cShowHUB(superView: nil, msg: "临时：最新选择的视频是有效的视频")
                }
            }else{
                self?.chosedAsset = selectedPhotoData.first
            }
            
        }
        return vc
    }()
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        showNavigation()
        photoMaterialVc.hiddenNavigation()

    }
    
    override func viewDidLoad() {
        super.viewDidLoad()

        leftButton(image: nil, imageName: nil, tintColor: .white)
        rightButtonItem(image: nil, title: "下一步   ", titleColor: .white)
        navHeadImageView?.backgroundColor = .black
        
        addChildViewController(photoMaterialVc)
        view.addSubview(photoMaterialVc.view)
        
    }
    
    override func rightBtnClick(sender _: UIButton) {
        if let asset = self.chosedAsset{
            let vc = IntroduceController()
            vc.asset = asset
            navigationController?.pushViewController(vc, animated: true)
        }else{
            cShowHUB(superView: nil, msg: "需要选择一个视频")
        }
    }
}
